<?php
    
    require_once 'PEAR.php';

    /**
    * Image_Tools
    * A collection of image utilities
    * 
    * @access public
    * @package Image_Tools
    * @author Tobias Schlitt <tobias@schlitt.info>
    * @license http://www.php.net/license/3_0.txt The PHP License, version 3.0
    */


    class Image_Tools {

    	/**
    	* Unused
    	* Stores the image resource in the driver classes.
    	*
    	* @var resource image
    	*/
    	
    	var $img;
    	
    	/**
    	* Unused
    	* Stores the options in the driver classes.
    	*
    	* @var array
    	*/
    	
    	var $options = array();
    	
    	/**
    	* Factory (used!)
    	* This is the method to initialize an image tool. This method is called statically, 
    	* using the name of the tool and an array of options.
    	*
    	* @access public
    	* @param string $toolname The name of the tool used
    	* @param array $options An array of tool specific options
    	* @return mixed Image tool object or PEAR::Error on failure
    	*/
    	
    	function &factory ( $toolname, $options = array() ) {
    		@require_once 'Image/Tools/' . ucfirst($toolname) . ".php";
    		if (!class_exists('Image_Tools_'.$toolname)) {
    			return PEAR::raiseError("Class 'Image_Tools_$toolname' not found", 0);
    		}
    		$classname = 'Image_Tools_'.$toolname;
    		return new $classname ($options);
    	}
    	
    	
        /**
        * Constructor unsed
        * The constructure is only used by inheriting classes to
        * represent the packages driver structure.
        */

        function Image_Tools ( $options = array() ) {

        }
        
        /**
        * Unused
        * This method can optionally be overwriten by inheriting 
        * classes.
        *
        * @access public
        * @param array $options Associative array of options, driver specific
        */
        
        function setOptions ( $options ) {
        	foreach ( $options as $option => $value) {
				if (isset($this->options[$option])) {
					$this->options[$option] = $value;
				}
			}
        }
        
        /**
        * Unused
        * Set the used image. This method can optionally be 
        * overwriten by driver classes.
        *
        * @access public
        * @param resource image $img Use this custom image.
        */
        
        function setImage ( &$img ) {
        	$this->img =& $img;
        }
    }
?>
